 DEFINE PAGE00, SPACE=ROM
 SEGMENT PAGE00

 include "WFRNGOS.inc"

 public PutChar, DrawString, MeasureString, ResetTextLocation
 extern DEMulA, Font, PutSpriteOR

ResetTextLocation:
	push hl
	ld hl, 0
	ld (TextX), hl
	pop hl
	ret

; Draws the character A at TextX, TextY
PutChar:
	push hl
	push bc
	push de
	push af
	ld de, 5
	sub 20h
	call DEMulA
	ex hl, de
	ld ix, Font
	add ix, de
	ld b, 5
	ld a, (TextX)
	ld d, a
	add a, 4
	ld (TextX), a
	ld a, (TextY)
	ld e, a
	call PutSpriteOR
	pop af
	pop de
	pop bc
	pop hl
	ret

; Measures (HL) and returns width, height in b, c
MeasureString:
	ld bc, 0
	ld a, (hl)
	inc hl
	cp '\n'
	jr z, MeasureStringNewline
	cp '\r'
	jr z, MeasureStringNewline
	or a
	ret z
	ld a, 4
	add b, a
	jr MeasureString
	ret
MeasureStringNewline:
	ld a, 6
	add c, a
	ret

; Draws (HL) at TextX, TextY
DrawString:
	ld a, (hl)
	inc hl
	cp '\n'
	jr z, DrawStringNewline
	cp '\r'
	jr z, DrawStringNewline
	or a
	ret z
	call PutChar
	jr DrawString
DrawStringNewline:
	ld a, (TextY)
	add a, 6
	cp 60
	call nc, Scroll
	ld (TextY), a
	ld a, 0
	ld (TextX), a
	jr DrawString

Scroll:
	; Scroll the screen up
	push af
	ld a, 6
	call LCDUp
	pop af
	sub a, 6
	ret

LCDUp:	;shifts the LCD up by the amount in a
	push bc	;
	push de	;Preserve registers
	push hl	;
;Start Kerms method, which is way to big
;does the same thing though
	;ld l,a
	;xor a
	;ld h,a
	;add hl,hl
	;add hl,hl
 	;push hl
	;add hl,hl
	;pop de
	;add hl,de
	;push hl
	;ld de,768
	;ex de,hl
	;or a
	;sbc hl,de
	;push hl
	;pop bc
	;pop hl
	;ld de, LCDBuffer
	;add hl,de
	;ldir
;end Kerms Method
	ld b,a
LCDUpLoop
		push bc
		ld hl,LCDBuffer+12
		ld de,LCDBuffer
		ld bc,756
		ldir
		pop bc
		djnz LCDUpLoop
	pop hl	;
	pop de	;Restore registers
	pop bc	;
	ret
